
#include "base.as"

#library  lEPreorder  "EPreorder.ao"

import from lEPreorder

EP ==> ExtremalPreorder

X:MeasureSpace == DoubleFloat add 
    Rep == DoubleFloat; import from Rep
    
    min:% == per 0.0
    max:% == per 1.0
    
    maximalNGT(x:%):Generator % == generate { yield x }
    minimalNLT(x:%):Generator % == generate { yield x }
    
    measure(x:%):P == prob rep x

   
X2 == X*X
I2 == Interval X
import from X2,I2

print << min$X2 << newline
print << max$X2 << newline
print << min$I2 << newline
print << max$I2 << newline   

import from DoubleFloat,Record(l:DoubleFloat,h:DoubleFloat)
xX2:X2 == [1.0,0.90] pretend X2
xI2:I2 == [1.0,0.90] pretend I2

print << xX2 << newline
print << xI2 << newline

print << "maximalNGT (" << xX2 << ":xX2 ):" << newline
for xx in maximalNGT xX2 repeat
    print << "   " << xx << newline
print << "minimalNLT (" << xX2 << ":xX2 ):" << newline
for xx in minimalNLT xX2 repeat
    print << "   " << xx << newline
print << "maximalNGT (" << xI2 << ":xI2 ):" << newline
for xx in maximalNGT xI2 repeat
    print << "   " << xx << newline
print << "minimalNLT (" << xI2 << ":xI2 ):" << newline
for xx in minimalNLT xI2 repeat
    print << "   " << xx << newline 
    
f:MeasureSpace(X,P) == hom ( (x:X):P +-> x pretend P, (p:P):X +-> p pretend X, (p:P):X +-> p pretend X, min$X, max$X, min$P, max$P )

int:Generator Interval P == integral(X,f)

step! int
print << value int << newline

step! int
print << value int << newline

